import * as React from 'react';
import { FieldValues, FieldName, UseFormOptions, OnSubmit, ValidationPayload, ElementLike, NameProp, ManualFieldError } from './types';
export default function useForm<FormValues extends FieldValues = FieldValues>({ mode, reValidateMode, validationSchema, defaultValues, nativeValidation, submitFocusError, validationSchemaOption, validateCriteriaMode, }?: UseFormOptions<FormValues>): {
    register: {
        <Element_1>(validateRule: Partial<{
            required: string | boolean | {
                value: boolean;
                message: string;
            };
            min: string | number | {
                value: string | number;
                message: string;
            };
            max: string | number | {
                value: string | number;
                message: string;
            };
            maxLength: string | number | {
                value: string | number;
                message: string;
            };
            minLength: string | number | {
                value: string | number;
                message: string;
            };
            pattern: RegExp | {
                value: RegExp;
                message: string;
            };
            validate: import("./types").Validate | Record<string, import("./types").Validate>;
        }> & NameProp): (ref: Element_1 | null) => void;
        <Element_2 extends ElementLike = ElementLike>(validateRule: Partial<{
            required: string | boolean | {
                value: boolean;
                message: string;
            };
            min: string | number | {
                value: string | number;
                message: string;
            };
            max: string | number | {
                value: string | number;
                message: string;
            };
            maxLength: string | number | {
                value: string | number;
                message: string;
            };
            minLength: string | number | {
                value: string | number;
                message: string;
            };
            pattern: RegExp | {
                value: RegExp;
                message: string;
            };
            validate: import("./types").Validate | Record<string, import("./types").Validate>;
        }>): (ref: Element_2 | null) => void;
        <Element_3>(ref: Element_3 | null, validateRule: Partial<{
            required: string | boolean | {
                value: boolean;
                message: string;
            };
            min: string | number | {
                value: string | number;
                message: string;
            };
            max: string | number | {
                value: string | number;
                message: string;
            };
            maxLength: string | number | {
                value: string | number;
                message: string;
            };
            minLength: string | number | {
                value: string | number;
                message: string;
            };
            pattern: RegExp | {
                value: RegExp;
                message: string;
            };
            validate: import("./types").Validate | Record<string, import("./types").Validate>;
        }> & NameProp): void;
        <Element_4 extends ElementLike = ElementLike>(ref: Element_4 | null, validationOptions?: Partial<{
            required: string | boolean | {
                value: boolean;
                message: string;
            };
            min: string | number | {
                value: string | number;
                message: string;
            };
            max: string | number | {
                value: string | number;
                message: string;
            };
            maxLength: string | number | {
                value: string | number;
                message: string;
            };
            minLength: string | number | {
                value: string | number;
                message: string;
            };
            pattern: RegExp | {
                value: RegExp;
                message: string;
            };
            validate: import("./types").Validate | Record<string, import("./types").Validate>;
        }> | undefined): void;
    };
    unregister: {
        (name: FieldName<FormValues>): void;
        (names: FieldName<FormValues>[]): void;
    };
    clearError: {
        (): void;
        (name: FieldName<FormValues>): void;
        (names: FieldName<FormValues>[]): void;
    };
    setError: {
        (name: ManualFieldError<FormValues>[]): void;
        (name: FieldName<FormValues>, type: Record<string, import("./types").ValidateResult>): void;
        (name: FieldName<FormValues>, type: string, message?: string | undefined): void;
    };
    handleSubmit: (callback: OnSubmit<FormValues>) => (e: React.BaseSyntheticEvent<object, any, any>) => Promise<void>;
    watch: {
        (): FormValues;
        <T extends FieldName<FormValues>>(field: T & string, defaultValue?: string | undefined): FormValues[T];
        (fields: FieldName<FormValues>[] | string[], defaultValues?: Partial<FormValues> | undefined): Partial<FormValues>;
    };
    reset: (values?: Partial<FormValues> | undefined) => void;
    setValue: <Name extends FieldName<FormValues>>(name: Name, value: FormValues[Name], shouldValidate?: boolean | undefined) => void | Promise<boolean>;
    triggerValidation: (payload?: ValidationPayload<FieldName<FormValues>, FormValues[FieldName<FormValues>]> | ValidationPayload<FieldName<FormValues>, FormValues[FieldName<FormValues>]>[] | undefined, shouldRender?: boolean | undefined) => Promise<boolean>;
    getValues: (payload?: {
        nest: boolean;
    } | undefined) => FormValues;
    errors: Partial<Record<FieldName<FormValues>, import("./types").FieldError>>;
    formState: {
        isValid: boolean;
        dirty: boolean;
        isSubmitted: boolean;
        submitCount: number;
        touched: FieldName<FormValues>[];
        isSubmitting: boolean;
    };
};
